=begin
#-----------------------------------------------------------------------
Copyright 2007-20012 TIG (c)
Permission to use, copy, modify, and distribute 
this software for any purpose and without fee is hereby granted, 
provided this notice appears in any copies.
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED 
WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------
It matches the orientation of a face to any connected 'co-edged' faces.
It mimics SketchUp's "Orient Faces" Tool.
It can sometimes produce slightly different results when more than two 
connected faces share a common edge.  Its results are equally logical, 
and who's to say how they should orient anyway ?
You can call it from other scripts thus:
  face.orient_faces
#-----------------------------------------------------------------------
Version:	1.0	20071215	First Issue.
            1.1 20080706    Algorithms improved etc - much faster.
			1.2 20120204    Checks of existing method!
#-----------------------------------------------------------------------
=end

module Enviz_SketchUp_Plugin

#unless Sketchup::Face.method_defined?(:orient_faces) ###v1.2
class Enviz_Orient_Faces
 def self.orient_faces(face)
    #model=Sketchup.active_model ###v1.1
    #a=Sketchup.version; b=a[0,1].to_i ###v1.1
	#if b > 6 ###v1.1
	#  model.start_operation("Orient Faces", true)
	#else
	#  model.start_operation("Orient Faces")
	#end#if ###v1.1
    @connected_faces=[]
	face.all_connected.each{|e|
	  if e.class==Sketchup::Face
		e.edges.each{|edge|
		  if edge.faces[1]
            @connected_faces<<e
            break ### found one ###v1.1
          end#if
        }
	  end#if
	}
    @connected_faces=[face] + @connected_faces ### self first in list
    @connected_faces.uniq! ###v1.1
	@awaiting_faces=@connected_faces
    @processed_faces=[face]
    @done_faces=[]
    msg="Orienting Faces"
    ###
	while @awaiting_faces[0] ###v1.1
      msg=msg+"."
	  @processed_faces.each{|face|
        if not @done_faces.include?(face)
	   #   Sketchup::set_status_text(msg,SB_PROMPT)
		  @face=face
          face_flip
        end#if
	  }
    end#while
	#Sketchup::set_status_text((""),SB_PROMPT)
	#model.commit_operation

 end#def
 def self.face_flip() ###v1.1
    @awaiting_faces=@awaiting_faces-[@face]
    @face.edges.each{|edge|
      rev1=edge.reversed_in?(@face)
      @common_faces=edge.faces-[@face]
      @common_faces.each{|face|
	    rev2=edge.reversed_in?(face)
        face.reverse! if @awaiting_faces.include?(face) and rev1==rev2
	    @awaiting_faces=@awaiting_faces-[face]
	    @processed_faces<<face
	  }
    }
    @done_faces<<@face
 end#def
 
end#if ###v1.2

end#class
